#!/usr/bin/perl 

####################################################################### 
#						                      #  
#                            NeoUpdate 	                              # 
#		   	   Version 1.10                               # 
# 	                                                              # 
#                    Created by Sofian Widjaja                        #  
#					                              # 
# Created on:  10/24/00         Last Modified on: 12/08/00            #  
# I can be reached at:          neomatrix@iamnewbie.com               # 
# Scripts Found at:             http://www.iamnewbie.com              # 
# Filename  :                   neoupdate.pl                          #
####################################################################### 
# Please use the forum at the site for support questions and not      # 
# email them. The forum is checked often.	                      # 
#######################################################################
# This program is free software; you can redistribute it and/or       #
# modify it under the terms of the GNU General Public License         #
# as published by the Free Software Foundation; either version 2      #
# of the License, or (at your option) any later version.              #
#                                                                     #
# This program is distributed in the hope that it will be useful,     #
# but WITHOUT ANY WARRANTY; without even the implied warranty of      #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       #
# GNU General Public License for more details.                        #
#                                                                     #
# You should have received a copy of the GNU General Public License   #
# along with this program; if not, write to the Free Software         #
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA           #
# 02111-1307, USA.                                                    #
#######################################################################


require LWP; 
require URI::URL; 
use LWP;


if ($ARGV[0] eq ""){
die "error: command syntax must be : $0 filename\n"; 
}
if (!(-e $ARGV[0])){
die "error : $ARGV[0] : No such file or directory\n";
}

require "$ARGV[0]";

$time = localtime;

if($ipmethod eq "local"){
  $newip = getip($device);
}elsif($ipmethod eq "internet"){
  $newip = getip2();
}else{
  die "error : Mo method of retrieving ip selected\n";
}

$oldip = getoldip();
print "$oldip\n";
$output;
$x = 0;
$apachetmp="/tmp/apache.temp";

if ($dns eq "centralinfo"){
foreach (@s){
  if ($_ ne "" && $d[$x] eq ""){
     $d[$x] = $newip;
  }
  $x++;
}
}

if ($newip ne $oldip)      ## if no changes in ip do nothing
{

if ($dns eq "centralinfo"){

$base_URL="http://www.centralinfo.net"; 
$url1="?dnsname=$domain&email=$email&refresh=$refresh&retry=$retry&expire=$expire&ttl=$ttl";
$url2="&s1=$s[1]&t1=$t[1]&d1=$d[1]&s2=$s[2]&t2=$t[2]&d2=$d[2]&s3=$s[3]&t3=$t[3]&d3=$d[3]&s4=$s[4]&t4=$t[4]&d4=$d[4]";
$url3="&s5=$s[5]&t5=$t[5]&d5=$d[5]&s6=$s[6]&t6=$t[6]&d6=$d[6]&s7=$s[7]&t7=$t[7]&d7=$d[7]&s8=$s[8]&t8=$t[8]&d8=$d[8]";
$url4="&s9=$s[9]&t9=$t[9]&d9=$d[9]&s10=$s[10]&t10=$t[10]&d10=$d[10]&s11=$s[11]&t11=$t[11]&d11=$d[11]";
$url5="&s12=$s[12]&t12=$t[12]&d12=$d[12]&s13=$s[13]&t13=$t[13]&d13=$d[13]&s14=$s[14]&t14=$t[14]&d14=$d[14]";
$url6="&s15=$s[15]&t15=$t[15]&d15=$d[15]&s16=$s[16]&t16=$t[16]&d16=$d[16]&s17=$s[17]&t17=$t[17]&d17=$d[17]";
$url7="&s18=$s[18]&t18=$t[18]&d18=$d[18]&s19=$s[19]&t19=$t[19]&d19=$d[19]&s20=$s[20]&t20=$t[20]&d20=$d[20]";
$url8=$url1.$url2.$url3.$url4.$url5.$url6.$url7;

$total_url=$base_URL."/dns_services_modify_form.asp".$url8;
$post_data="redir=dns_services.asp&menu=&ref=&name=$username&password=$password"; 

}elsif ($dns eq "yi"){
$total_url="http://www.yi.org/bin/dyndns.fcgi?ipaddr=$newip";
$post_data="";
}else{
die "Error : Unknown DNS Service\n";

}

$return=update($total_url,$post_data); 

if ($return = "1"){
if($enable_firewall eq "1")
{
  open(OUTPUT, "$firewall |");
  while (<OUTPUT>){
  $output .= $_;
  $output .= "\n";
  }
  close(OUTPUT);
}

if($oldip ne "undefined"){
  if($enable_httpd eq "1")
  {
    changeip();
    open(OUTPUT, "$httpd |");
    while (<OUTPUT>){
    $output .= $_;
    $output .= "\n";
    }
    close(OUTPUT);
  }
}
open(IPFILE, ">$ipfile") || die "can't open $ipfile : $! ";
print IPFILE $newip;
close(IPFILE);

if($enable_log eq "1"){
logipchange();
}

}


if ($dns eq "yi"){
  $domain = "$username.yi.org";
}

if ($enable_mail eq "1"){
if ($return eq "1"){ 

open MAIL,"| $sendmail" or die "Could not open sendmail: $!";
print MAIL<<EOT;
To: $emailadd
Subject: Neoupdate Success


Date: $time
$output
DNS record for $domain has been updated.
IP changed from $oldip to $newip.
$newip save in $ipfile.
EOT
close MAIL or die "Could not close sendmail : $!";
}else{ 
open MAIL,"| $sendmail" or die "Could not open sendmail: $!";
print MAIL<<EOT;
To: $emailadd
Subject: Neoupdate Error

Date : $time
$output
Error occured while trying to update $domain.

HTTP ERROR : $message

EOT


close MAIL or die "Could not close sendmail : $!";
} 
}



}

## update dns account

sub update(){ 
my($get_url,$data)=@_; 
my($content_type,$method, $ua, $url, $request, $response); 

$content_type="application/x-www-form-urlencoded"; 
$method="POST"; 

$headers= new HTTP::Headers 
'Content-Type'   =>  $content_type, 
'MIME-Version'   =>  '1.0', 
'Date'           =>  HTTP::Date::time2str(time), 
'Accept'         =>  'text/html'; 

$ua= new LWP::UserAgent; 

$ua->agent("Mozilla/4.7 [en] (Linux NeoUpdate)"); # Define User Agent 

$url= new URI::URL($get_url); 
$request= new HTTP::Request($method, $url, $headers,$data); 
if ($dns eq "yi"){
$request->authorization_basic( $username, $password );
}

$response= $ua->request($request); 

# $message2 = $response->as_string;  ## return $response as string 
 $message = $response->status_line;  ## return only status_line from response
#print "$message2";


if ($response->is_success){ 
return 1;
}else{ 
return 0;
}
} 

## get old ip

sub changeip()
{
open (APACHEIN, $httpconf) || die "Could not open $httpconf : $!";
open (APACHEOUT, ">$apachetmp") || die "cannot create $apachetmp : $!";
while (<APACHEIN>){
$_ =~ s/$oldip/$newip/g;
print APACHEOUT $_;
}
close(APACHEIN) || die "can't close $httpconf : $!";
close(APACHEOUT) || die "can't close $apachetmp : $!";
system("mv $apachetmp $httpconf");
}


sub getoldip()
{
my($ip);
open (IPFILE, "$ipfile") || (return $oldip="undefined");
chomp($ip = <IPFILE>);
close(IPFILE);
return $ip;
}

## get ip from network interface

sub getip(){
($device) = @_;
my(@newip,$newip,$nic);
$nic = qx(/sbin/ifconfig $device);
@newip = grep(/inet /, split(/[\n\r]/, $nic));
$newip = $newip[0];
$newip =~ s/\sinet //;
$newip =~ s/ .*$//;
if ($newip =~ m/(\d+)\.(\d+)\.(\d+)\.(\d+)/){ 
return $newip;
}else{
die "Aborting : Can't retrieve ip information from $device\n";
}
}    


sub getip2(){ 
my $newip; 
$ua = new LWP::UserAgent; 
$ua->agent("Mozilla/4.7 [en] (Linux NeoUpdate)"); 

## This is the url to a script that returns your public IP without any HTML 
$req = new HTTP::Request 'GET' => '$ipserver'; 
$req->header('Accept' => 'text/html'); 
# send request 
$res = $ua->request($req); 

# check the outcome 
if ($res->is_success) { 
#print $res->content; Used to test output 
$res->content =~ m/(\d+)\.(\d+)\.(\d+)\.(\d+)/; 
$newip = $&;

}else { 
print "Error: " . $res->code . " " . $res->message; 
die "Couldn't retrive ip : aborting\n";
} 
#print $newip; used to test output 
return $newip; 
}

sub logipchange(){ 
open (LOGFILE, ">>$logfile") || die "can't open $logfile :  $! "; 
($mi,$h,$d,$m,$y) = (localtime)[1,2,3,4,5]; 
printf LOGFILE ("%04d%02d%02d%02d%02d;", $y+1900,$m+1,$d,$h,$mi); 
print LOGFILE "$newip\n"; 
close (LOGFILE); 
}  
